Description
The following code, when executed on Linux, leads to a segmentation fault:

OFFile* imageFile = new OFFile;

DcmOutputFileStream* outStream = nullptr;
imageFile->fopen (currentFilename.c_str (), "wb");
outStream = new DcmOutputFileStream(imageFile->file());
delete outStream;

delete imageFile;

The reason is that the "FILE *" handle is closed twice, once in the OFFile destructor and once in the DecmOutputFileStream

destructor. This apparently works on Windows but crashes on Linux.

Possible solutions:

e add method in OFFile and/or DcmQOutputFileStream that sets the "FILE *" to NULL without calling fclose()

¢ permit an OFFile instance to be passed to DcmOutputFileStream by reference

¢ add a flag in the constructor in both classes indicating whether or not the file descriptor should be closed in the destructor

History

#1 - 2022-05-10 17:40 - Marco Eichelberg

Reported 2022-05-04 by Franz Reitner <franz.reitner@excelitas.com>

#2 - 2022-10-30 12:38 - Marco Eichelberg
- Status changed from New to Closed

- % Done changed from 0 to 100

- Estimated time set to 1:00 h

Closed by commit #0c5d89074.
